Bug 471669 - [G45 X4500HD] Compiz - windows are not properly updated
[G45 X4500HD] Compiz - windows are not properly updated
Status: CLOSED INSUFFICIENT_DATA
Product: Fedora
Classification: Fedora
Component: xorg-x11-drv-intel (Show other bugs)
11
All Linux
medium Severity medium
: ---
: ---
Assigned To: Adam Jackson
Fedora Extras Quality Assurance
http://bugs.freedesktop.org/show_bug....
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-11-14 17:25 EST by Mace Moneta
Modified: 2009-10-24 14:57 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-10-24 13:57:08 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Sample of the corruption of a window (902.67 KB, image/png)
2008-11-14 17:25 EST, Mace Moneta
no flags Details
dmesg after the corruption occurs (39.39 KB, text/plain)
2008-11-14 17:26 EST, Mace Moneta
no flags Details
dmidecode (13.72 KB, text/plain)
2008-11-14 17:27 EST, Mace Moneta
no flags Details
lspci (20.78 KB, text/plain)
2008-11-14 17:27 EST, Mace Moneta
no flags Details
Xorg.0.log (121.37 KB, text/plain)
2008-11-14 17:28 EST, Mace Moneta
no flags Details
Xorg.0.log (81.79 KB, text/plain)
2009-03-26 19:06 EDT, Mace Moneta
no flags Details

  None (edit)
Description Mace Moneta 2008-11-14 17:25:21 EST
Created attachment 323663 [details]
Sample of the corruption of a window

Description of problem:

I normally have many windows open (over a dozen), some full screen, across six workspaces.  With Compiz active, the windows and/or window decorations will become corrupted.  When the corruption occurs, performance of all Compiz operations also drops significantly.

Version-Release number of selected component (if applicable):

kernel-2.6.27.5-109.fc10.x86_64
xorg-x11-server-Xorg-1.5.3-3.fc10.x86_64
xorg-x11-drv-i810-2.5.0-3.fc10.x86_64

How reproducible:

Always

Steps to Reproduce:
1.Start Compiz
2.Open many windows across 6 workspaces
3.Switch workspaces, rotate the cube, watch a video.  Eventually the problem occurs.
  
Actual results:

Windows and or window decorations become corrupted (see screencap, attached).

Expected results:

No corruption of the display.

Additional info: dmesg, lspci, dmidecode, Xorg.0.log will be attached
Comment 1 Mace Moneta 2008-11-14 17:26:36 EST
Created attachment 323664 [details]
dmesg after the corruption occurs
Comment 2 Mace Moneta 2008-11-14 17:27:04 EST
Created attachment 323665 [details]
dmidecode
Comment 3 Mace Moneta 2008-11-14 17:27:28 EST
Created attachment 323666 [details]
lspci
Comment 4 Mace Moneta 2008-11-14 17:28:29 EST
Created attachment 323667 [details]
Xorg.0.log

There is no xorg.conf in use.
Comment 5 Mace Moneta 2008-11-14 18:48:30 EST
In the Nvidia Linux forum, someone had complained about the same thing.  Yesterday, Nvidia responded with this, which I thought was interesting:

"This shouldn't be new, and this behavior is not actually caused by the NVIDIA driver: in the Debian/Ubuntu and RHEL/Fedora repositories, the X server is patched to remove the functionality that initializes the contents of new redirected windows to avoid doing blits from the framebuffer to system memory window pixmaps. Since those blits aren't a performance problem with the NVIDIA driver, we've restored this functionality on the driver side in the 180.xx release series."
Comment 6 Matěj Cepl 2008-11-14 19:31:23 EST
(In reply to comment #5)
> In the Nvidia Linux forum, someone had complained about the same thing. 
> Yesterday, Nvidia responded with this, which I thought was interesting:

Sorry, what nvidia problems with Fedora Xorg server has common with this bug which is about intel driver?
Comment 7 Mace Moneta 2008-11-14 21:08:57 EST
The Nvidia folks indicated that the problem was not in the Nvidia driver, but rather the result of a Fedora patch, according to the quote above.

I'm not saying that it's true, but I'm having the problem with the Intel driver, and folks are also having the problem with the proprietary Nvidia driver.

They could certainly be two separate issues, I just thought the information might be useful in isolating the issue, if you're familiar with the patch they are referring to.
Comment 8 Mace Moneta 2008-11-15 15:18:52 EST
I reduced the number of workspaces to four, and kept the number of open windows under 10.  Running that way, I can no longer recreate the corruption.  Too many open windows triggers the problem, which sounds like a memory management issue to me.

I should note that I also have 8GB of RAM in this machine; don't know if the Intel driver has an issue with that.
Comment 9 Mace Moneta 2008-11-17 15:13:44 EST
Just noting that the corruption still occurs with kernel-2.6.27.5-113.fc10.x86_64.
Comment 10 Mace Moneta 2008-11-17 16:25:51 EST
Same with xorg server 1.5.3-5.
Comment 11 Mace Moneta 2008-11-18 14:41:21 EST
I'm now running with kernel-2.6.27.5-116.fc10.x86_64, and so far I've not been able to recreate the corruption.  I'll give it a day and report back.
Comment 12 Mace Moneta 2008-11-19 11:46:15 EST
I've been logged in to the same session, running with 16-20 windows since installing the -116 kernel.  I've had only 4 incidents of corruption, but they are different.

Previously, once a window became corrupted (after a few minutes of use), continued use would spread the problem.  More windows and even the desktop background would turn to illegible noise.  At that point, ctrl-alt-backspace was the only way out.

Now, within a minute or so of each corruption, the window "heals" - the correct contents are restored.  The problem does not spread, and the login session remains usable.

I don't know how you'd like to categorize this.  Is this a new issue (close this bug and open a new bug), or has the existing problem simply reduced in severity?
Comment 13 Bug Zapper 2008-11-26 00:24:17 EST
This bug appears to have been reported against 'rawhide' during the Fedora 10 development cycle.
Changing version to '10'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 14 Mace Moneta 2008-12-01 09:48:12 EST
Resizing the window slightly is the fastest and easiest way to correct the corruption.  If the desktop background get corrupted, switching to another background and back corrects it.  

The problem occurs after a switching workspaces.  If I rotate the cube (ctrl-alt-drag) and hold it, I can observe various windows around the cube corrupting.  Sometimes the correct contents are restored, sometimes not.

Current software:

kernel-2.6.27.7-130.fc10.x86_64
xorg-x11-drv-i810-2.5.0-3.fc10.x86_64
mesa-libGL-7.2-0.14.fc10.i386
mesa-libGLU-7.2-0.14.fc10.x86_64
mesa-dri-drivers-7.2-0.14.fc10.x86_64
mesa-libGLU-7.2-0.14.fc10.i386
mesa-libGL-7.2-0.14.fc10.x86_64
compiz-fusion-extras-0.7.6-6.fc10.x86_64
compiz-0.7.6-17.fc10.x86_64
compiz-manager-0.6.0-8.fc10.noarch
gnome-compiz-manager-0.10.4-4.fc10.x86_64
compiz-fusion-gnome-0.7.6-7.fc10.x86_64
compizconfig-python-0.7.6-1.fc10.x86_64
compiz-fusion-0.7.6-7.fc10.x86_64
compiz-gnome-0.7.6-17.fc10.x86_64
compiz-fusion-extras-gnome-0.7.6-6.fc10.x86_64
libcompizconfig-0.7.6-2.fc10.x86_64
Comment 15 Mace Moneta 2008-12-19 15:38:15 EST
I updated the URL for this bug to point to the FreeDesktop bug 18843, which in comment 6 indicates:

------- Comment  #6 From Eric Anholt  2008-12-18 19:26:37 PST  [reply] -------

My guess is a later I830TexOffsetStart is kicking out an earlier one, as there
doesn't appear to be any protection to keep the buffer pinned while its offset
is used in the GLX context's batchbuffer.  This should be fixed with DRI2.

---

I don't know if that's something that can be patched in the interim, since DRI2 isn't even in the approved list for F11, pushing a fix out over a year.
Comment 16 Ben Boeckel 2009-02-20 23:24:44 EST
I am still seeing this with the following using KDE desktop effects:

kernel-2.6.27.15-170.2.24.fc10.x86_64
xorg-x11-drv-i810-2.5.0-4.fc10.x86_64
xorg-x11-server-Xorg-1.5.3-11.fc10.x86_64
xorg-x11-server-common-1.5.3-11.fc10.x86_64
mesa-libGL-7.2-0.15.fc10.x86_64
mesa-libGLU-7.2-0.15.fc10.x86_64
mesa-dri-drivers-7.2-0.15.fc10.x86_64

I have seen it occur with as few as 2 or 3 windows open. Also, the wallpaper and panel of plasma can get corrupted, usually not at the same time.
Comment 17 Mace Moneta 2009-03-26 19:06:37 EDT
Created attachment 336924 [details]
Xorg.0.log

Just a status update.  I'm currently running current rawhide:

kernel-2.6.29-9.fc11.x86_64
mesa-dri-drivers-7.5-0.2.fc11.x86_64
mesa-libGL-7.5-0.2.fc11.x86_64
mesa-libGL-devel-7.5-0.2.fc11.x86_64
mesa-libGLU-7.5-0.2.fc11.x86_64
mesa-libGLU-devel-7.5-0.2.fc11.x86_64
xorg-x11-drv-intel-2.6.99.902-1.fc11.x86_64

I tried enabling compiz, and it seemed to be working well.  After about 5 hours, the screen corruption re-occured.  Since this is now using DRI2, that doesn't seem to be the root cause.
Comment 18 Mace Moneta 2009-03-26 19:30:50 EDT
Sorry, please ignore the previous comment.  DRI2 was not enabled, because UXA was not enabled.  UXA corrupts everything, even with tiling disabled, so I can't use that.
Comment 19 Mace Moneta 2009-04-08 09:37:51 EDT
With the latest update, KMS+UXA is working well without Compiz.  If Compiz is enabled, windows are not properly updated.  I see this most often in terminal windows.  For example, I'll ssh to another system and get an all white terminal window and the cursor will move to the prompt location, but there is no text on the screen.  Clearing the screen causes text to appear, but portions end up getting lost again with use.

kernel-2.6.29.1-52.fc11.x86_64
libdrm-2.4.5-4.fc11.i586
libdrm-2.4.5-4.fc11.x86_64
mesa-dri-drivers-7.5-0.7.fc11.i586
mesa-dri-drivers-7.5-0.7.fc11.x86_64
mesa-libGL-7.5-0.7.fc11.i586
mesa-libGL-7.5-0.7.fc11.x86_64
mesa-libGLU-7.5-0.7.fc11.i586
mesa-libGLU-7.5-0.7.fc11.x86_64
xorg-x11-drv-intel-2.6.99.902-2.fc11.x86_64
Comment 20 Vedran Miletić 2009-09-06 03:44:24 EDT
Reporter, any changes with recent updates?
Comment 21 Mace Moneta 2009-10-24 13:57:08 EDT
I've installed an Nvidia card, and I'm using the proprietary driver, with no problems.  I will no longer be able to update this report, so I'm closing it.
Comment 22 Ben Boeckel 2009-10-24 14:57:23 EDT
I also an no longer seeing this with my Intel card (KWin) so I don't think it's occurring anymore.

Note You need to log in before you can comment on or make changes to this bug.